/**
 * @file    shellmatta_crc.h
 * @brief   cyclic redundancy check functions of shellmatta
 * @author  Simon Fischer <fischer.simon.1991@gmail.com>
 */

#ifndef _SHELLMATTA_CRC_H_
#define _SHELLMATTA_CRC_H_

#include <stdint.h>

#define CRC32_POLYNOM   0x04c11db7      /* crc-32 ethernet 802.3 */
#define BITS_PER_BYTE   ((uint8_t)8)    /* amount of bits per byte; to avoid magic number */

uint32_t crc32Calc(char* data, uint16_t size);
uint32_t crc32Slow(char* data, uint16_t size);

#ifndef CRC_NO_LOOKUP
uint32_t crc32Fast(char* data, uint16_t size, uint32_t* lookupTable);
#endif

#endif /* _SHELLMATTA_CRC_H_ */